Machines
Create a machine
Starts a fresh Ubuntu machine for the agent (or forks one of its machines) with an auto-stop window. Returns 202 while provisioning; poll until state is ready. Billed per second of the plan’s machine time.
POST
/
api
/
v1
/
machines
Create a machine
curl --request POST \
--url https://agent-loadout.com/api/v1/machines \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"agent_id": "<string>",
"name": "<string>",
"ttl_seconds": 4503599627370526,
"env": {},
"inject_credential_ids": [
"<string>"
],
"agent_token_capabilities": [
"<string>"
],
"setup_script": "<string>",
"from_machine_id": "<string>",
"idempotency_key": "<string>"
}
'import requests
url = "https://agent-loadout.com/api/v1/machines"
payload = {
"agent_id": "<string>",
"name": "<string>",
"ttl_seconds": 4503599627370526,
"env": {},
"inject_credential_ids": ["<string>"],
"agent_token_capabilities": ["<string>"],
"setup_script": "<string>",
"from_machine_id": "<string>",
"idempotency_key": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
agent_id: '<string>',
name: '<string>',
ttl_seconds: 4503599627370526,
env: {},
inject_credential_ids: ['<string>'],
agent_token_capabilities: ['<string>'],
setup_script: '<string>',
from_machine_id: '<string>',
idempotency_key: '<string>'
})
};
fetch('https://agent-loadout.com/api/v1/machines', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://agent-loadout.com/api/v1/machines",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'agent_id' => '<string>',
'name' => '<string>',
'ttl_seconds' => 4503599627370526,
'env' => [
],
'inject_credential_ids' => [
'<string>'
],
'agent_token_capabilities' => [
'<string>'
],
'setup_script' => '<string>',
'from_machine_id' => '<string>',
'idempotency_key' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://agent-loadout.com/api/v1/machines"
payload := strings.NewReader("{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://agent-loadout.com/api/v1/machines")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://agent-loadout.com/api/v1/machines")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"machine": {
"id": "<string>",
"agent_id": "<string>",
"name": "<string>",
"size": "small",
"state": "provisioning",
"ttl_seconds": 0,
"archive_after": "2023-11-07T05:31:56Z",
"ip": "<string>",
"ports": [
{
"port": 0,
"url": "<string>",
"title": "<string>",
"public": true
}
],
"injected_credential_ids": [
"<string>"
],
"has_agent_token": true,
"stop_reason": "manual",
"last_error": "<string>",
"started_at": "2023-11-07T05:31:56Z",
"stopped_at": "2023-11-07T05:31:56Z",
"charged_seconds": 0,
"reserved_seconds": 0,
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}Authorizations
agentTokenorganizationKey
Body
application/json
Mint an agent token with these capabilities and place it in AGENT_LOADOUT_TOKEN inside the machine. An agent connection can delegate only its granted permissions; reconnect and obtain explicit consent before requesting additional capabilities.
Maximum array length:
10Maximum string length:
40⌘I
Create a machine
curl --request POST \
--url https://agent-loadout.com/api/v1/machines \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"agent_id": "<string>",
"name": "<string>",
"ttl_seconds": 4503599627370526,
"env": {},
"inject_credential_ids": [
"<string>"
],
"agent_token_capabilities": [
"<string>"
],
"setup_script": "<string>",
"from_machine_id": "<string>",
"idempotency_key": "<string>"
}
'import requests
url = "https://agent-loadout.com/api/v1/machines"
payload = {
"agent_id": "<string>",
"name": "<string>",
"ttl_seconds": 4503599627370526,
"env": {},
"inject_credential_ids": ["<string>"],
"agent_token_capabilities": ["<string>"],
"setup_script": "<string>",
"from_machine_id": "<string>",
"idempotency_key": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
agent_id: '<string>',
name: '<string>',
ttl_seconds: 4503599627370526,
env: {},
inject_credential_ids: ['<string>'],
agent_token_capabilities: ['<string>'],
setup_script: '<string>',
from_machine_id: '<string>',
idempotency_key: '<string>'
})
};
fetch('https://agent-loadout.com/api/v1/machines', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://agent-loadout.com/api/v1/machines",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'agent_id' => '<string>',
'name' => '<string>',
'ttl_seconds' => 4503599627370526,
'env' => [
],
'inject_credential_ids' => [
'<string>'
],
'agent_token_capabilities' => [
'<string>'
],
'setup_script' => '<string>',
'from_machine_id' => '<string>',
'idempotency_key' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://agent-loadout.com/api/v1/machines"
payload := strings.NewReader("{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://agent-loadout.com/api/v1/machines")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://agent-loadout.com/api/v1/machines")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"agent_id\": \"<string>\",\n \"name\": \"<string>\",\n \"ttl_seconds\": 4503599627370526,\n \"env\": {},\n \"inject_credential_ids\": [\n \"<string>\"\n ],\n \"agent_token_capabilities\": [\n \"<string>\"\n ],\n \"setup_script\": \"<string>\",\n \"from_machine_id\": \"<string>\",\n \"idempotency_key\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"machine": {
"id": "<string>",
"agent_id": "<string>",
"name": "<string>",
"size": "small",
"state": "provisioning",
"ttl_seconds": 0,
"archive_after": "2023-11-07T05:31:56Z",
"ip": "<string>",
"ports": [
{
"port": 0,
"url": "<string>",
"title": "<string>",
"public": true
}
],
"injected_credential_ids": [
"<string>"
],
"has_agent_token": true,
"stop_reason": "manual",
"last_error": "<string>",
"started_at": "2023-11-07T05:31:56Z",
"stopped_at": "2023-11-07T05:31:56Z",
"charged_seconds": 0,
"reserved_seconds": 0,
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"hint": "<string>",
"details": {}
}
}